<template>
  <Dialog v-model="dialogVisible" :title="dialogTitle" width="650">
    <el-form
      ref="formRef"
      v-loading="formLoading"
      :model="formData"
      :rules="formRules"
      label-width="120px"
    >
<!--      <el-row>-->
<!--        <el-col :span="15">-->
<!--          <el-form-item label="RFID编码" prop="rfidCode">-->
<!--            <el-input-->
<!--              v-model="formData.rfidCode"-->
<!--              placeholder="请输入RFID编码"-->
<!--              class="!w-240px"-->
<!--            />-->
<!--          </el-form-item>-->
<!--        </el-col>-->
<!--        <el-col :span="8">-->
<!--          <el-form-item label-width="80">-->
<!--            <el-switch-->
<!--              v-model="autoGenFlag"-->
<!--              active-color="#13ce66"-->
<!--              active-text="自动生成"-->
<!--              @change="handleAutoGenChange"-->
<!--            />-->
<!--          </el-form-item>-->
<!--        </el-col>-->
<!--      </el-row>-->
      <el-form-item label="RFID内容" prop="rfid">
        <el-input
          v-model="formData.rfid"
          placeholder="请输入RFID内容"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="RFID类型" prop="rfidType">
        <el-select
          v-model="formData.rfidType"
          placeholder="请选择RFID类型"
          clearable
          class="!w-240px"
        >
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.RFID_TOKEN_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.RFID_TOKEN_STATUS)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input
          v-model="formData.remark"
          placeholder="请输入备注"
          class="!w-240px"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button :disabled="formLoading" type="primary" @click="submitForm">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>

<script lang="ts" setup>
import { ref, reactive } from 'vue'
import { DICT_TYPE, getStrDictOptions } from '@/utils/dict'
import * as RfidApi from '@/api/hw/hardware/rfid/index'
// import * as AutocodeApi from '@/api/system/autocode/rule'

defineOptions({ name: 'RfidTokenForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const autoGenFlag = ref(false) // 是否自动生成编码

const formData = ref({
  rfidId: undefined,
  rfidCode: '',
  rfid: '',
  rfidType: undefined,
  status: '1',
  remark: ''
})

const formRules = reactive({
  // rfidCode: [{ required: true, message: 'RFID编码不能为空', trigger: 'blur' }],
  rfid: [{ required: true, message: 'RFID内容不能为空', trigger: 'blur' }],
  rfidType: [{ required: true, message: 'RFID类型不能为空', trigger: 'blur' }]
})

const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await RfidApi.selectIsRfidTokenById(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef.value) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value
    if (formType.value === 'create') {
      await RfidApi.insertIsRfidToken(data)
      message.success(t('common.createSuccess'))
    } else {
      await RfidApi.updateIsRfidToken(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    rfidId: undefined,
    rfidCode: '',
    rfid: '',
    rfidType: undefined,
    status: '1',
    remark: ''
  }
  autoGenFlag.value = false
  formRef.value?.resetFields()
}

/** 自动生成编码 */
// const handleAutoGenChange = async (value: boolean) => {
//   if (value) {
//     formData.value.rfidCode = await AutocodeApi.genCode('RFID_CODE')
//   } else {
//     formData.value.rfidCode = ''
//   }
// }
</script>
